#ifndef MYSQL_H
#define MYSQL_H

#define DB_TABLE_USERDATA "users"    // table containing the authentication data of users
#define DB_TABLE_STATIONS "stations" // table containing the list of stations for every user that uses the VCR functionality
#define DB_TABLE_SCHEDULE "schedule" // schedule information for every user that uses the VCR functionality
#define DB_TABLE_DVDINFO  "dvdinfo"  // global DVD data that are queried to display information about this DVD and to be filled with new data when a user enters the data for an unknown DVD manually
#define DB_TABLE_CDINFO   "cdinfo"   // global CD data that are queried to display information about this CD and to be filled with new data when a user enters the data for an unknown CD manually
#define DB_TABLE_HOMELOAD "homeload" // currently unused

#define ERR_MYSQL_INIT_FAILED       0x10010000
#define ERR_MYSQL_CONNECT_FAILED    0x10020000
#define ERR_MYSQL_QUERY_FAILED      0x10030000
#define ERR_MYSQL_NOT_INITIALIZED   0x10040000
#define ERR_MYSQL_INVALID_RESULTSET 0x10050000

#include <mysql.h>
#include <stdio.h>

#include "mysqlaccess.h"

extern int initSQLConnection();
extern void *doSQLQuery(char *query);
extern char **getNextSQLResult(void *res);
extern int freeSQLQuery(void *res);
extern int deinitSQLConnection(void);

#endif


