/*
 * Copyright (c) 2004-2009 by VWP
 */

#include "maindefs.h"

#include <stdio.h>
#include <stdarg.h>
#include <string.h>
#include <stdlib.h>

#include "platforms.h"



#ifdef ENV_WINDOWS

#include <process.h>
#include "Commctrl.h"
#include "resource.h"
#ifndef ENV_FPEERD
#ifndef ENV_STREAMPEER
#ifndef ENV_LSERVED
#include "dirent.h"
#endif
#endif
#endif

#define WIN_WIDTH    450
#define WIN_HEIGHT   200
#define LOGMEML    30000
#ifdef ENV_FCASTD
 #define YOFFSET 15
#else
 #define YOFFSET 15+WIN_HEIGHT
#endif

static HWND    MyWindow,LogHnd,hState;
static char    leave=false;
static MSG     IMsg;
static char   *LogMemA,*LogPtr=NULL;



int inet_aton(const char *cp, struct in_addr *inp) {

  int i;
  unsigned int ip=0;
  char *tmp=(char*)cp;
  for (i=24; ;) {
    long j;
    j=strtoul(tmp,&tmp,0);
    if (*tmp==0) {
      ip|=j;
      break;
    }
    if (*tmp=='.') {
      if (j>255) return 0;
      ip|=(j<<i);
      if (i>0) i-=8;
      ++tmp;
      continue;
    }
    return 0;
  }
  inp->s_addr=htonl(ip);
  return 1;
}



extern int asprintf (char **str, const char *fmt, ...)

{

char    tmp[25000]; // should be big enough for everything
va_list ap;
int len = 0;

va_start (ap,fmt);
len = vsprintf (tmp,fmt, ap);
va_end (ap);

*str=(char*)malloc(len+1);
if (!*str) return -1;
va_start (ap,fmt);
vsprintf (*str,fmt, ap);
va_end (ap);
return len;
}


char *strndup(const char *s,size_t n)
{
char *newString;

size_t len =strlen (s);
if (len>n) len=n;
newString =(char*)malloc (len + 1);

if (newString == NULL) return NULL;

newString[len] = '\0';
return (char*)memcpy (newString, s, len);
}



bool startThread(void* func(void*),void *arg,FILE *logHandle)
{
unsigned int threadID;

if ((unsigned int)_beginthreadex(NULL, 0,(unsigned int(__stdcall*)(void*))func,arg, 0, &threadID )==0)return false;
return true;
}



void HandleLogList(char *Buffer)
{
char *SPtr,*TPtr;
int   BufLen;

if (!LogPtr) return;
BufLen=strlen(Buffer);
if (LogPtr+BufLen>=LogMemA+LOGMEML)
   {
   TPtr=(char*)LogMemA;
   SPtr=(char*)(LogMemA+BufLen+1);
   while (*SPtr!=0x0A) SPtr++;
   SPtr++;
   while ((SPtr<LogPtr) && (SPtr!=0x00))
      {
      *TPtr=*SPtr;
      TPtr++;
      SPtr++;
      }
   LogPtr=TPtr;
   }
if (LogPtr>LogMemA)
   {
   *LogPtr=0x0D; LogPtr++;
   *LogPtr=0x0A; LogPtr++;
   }
strcpy(LogPtr,Buffer);
LogPtr+=BufLen;
SetWindowText(LogHnd,LogMemA);
SendMessage(LogHnd,EM_LINESCROLL,0,30000);
}


#ifndef ENV_STREAMPEER
void showLog(FILE *FHandle,char *format,...)
{
va_list  arglist;
char     sText[1500];

va_start(arglist,format);
vsprintf(sText,format,arglist);
va_end(arglist);
if (sText[strlen(sText)-1]=='\n') sText[strlen(sText)-1]='\0';
HandleLogList(sText);
if (FHandle) fprintf(FHandle,"%s\n",sText);
}


void PlaceControls(void)
{
#define BOTTOM_OFFSET 20

RECT     MyRect;
int      width,height;

GetClientRect(MyWindow,&MyRect);
width=MyRect.right-MyRect.left;
height=MyRect.bottom-MyRect.top;

MoveWindow(LogHnd,0,0,width,height-BOTTOM_OFFSET,true);

}



static LRESULT CALLBACK _export MainWndProc(HWND hWnd,UINT message,WPARAM wParam,LPARAM lParam)
{
LPMINMAXINFO  mmi;
//char          stddir[300];
//OPENFILENAME  MyFileDialog;

switch (message)
   {
   case WM_SIZE:
      PlaceControls();
      MoveWindow (hState,0,HIWORD(lParam)-10,LOWORD(lParam), HIWORD(lParam),true);
      break;
   case WM_CREATE:
      return (DefWindowProc(hWnd, message, wParam, lParam));
   case WM_DESTROY:
      PostQuitMessage(0);   // this is the end...
      leave=true;
      break;
   case WM_CLOSE:
      // Leave==true;
      DestroyWindow(hWnd);
      break;
   case WM_GETMINMAXINFO:
      mmi=(LPMINMAXINFO) lParam;
      mmi->ptMinTrackSize.x=400;
      mmi->ptMinTrackSize.y=0;
      break;
   default:
      return (DefWindowProc(hWnd, message, wParam, lParam));
   }
return(0L);
}



int LeaveServer(int recv, int supp, int allseconds,char running)
{
char message[200];
char lastRunning=2;
int lastRecv=-1,lastSupp=-1;
#ifdef ENV_FCASTD
int lastAllseconds=-60;
int day,hour,min;
#endif
#ifdef ENV_FSUPPD
int lastAllseconds=-1;
int hour,min,sec;
#endif

#ifdef ENV_FPEERD
if ((recv!=lastRecv) || (supp!=lastSupp))
   {
   sprintf(message,"Direct / Relay: %d / %d",recv,supp);
   SendMessage(hState,SB_SETTEXT,1,(LPARAM)message);
   recv=lastRecv;
   supp=lastSupp;
   }
#else
 #ifdef ENV_FCASTD
 if (allseconds>lastAllseconds+60)
 {
    day=allseconds / 60 / 60 / 24;
    hour=(allseconds-(day * 60 * 60 * 24)) / 60 / 60;
    min=(allseconds-(day * 60 * 60 * 24)-(hour * 60 * 60)) / 60;
    sprintf(message,"Uptime: %dd %02d:%02d",day,hour,min);
    SendMessage(hState,SB_SETTEXT,2,(LPARAM)message);
    allseconds=lastAllseconds;
 }
 #else
  #ifdef ENV_FSUPPD
  if (allseconds>lastAllseconds)
  {
     hour=(allseconds/60/60);
     min=(allseconds-(hour*60*60))/60;
     sec=(allseconds-(hour*60*60)-(min*60));
     sprintf(message,"Media: %02d:%02d:%02d",hour,min,sec);
     SendMessage(hState,SB_SETTEXT,2,(LPARAM)message);
     allseconds=lastAllseconds;
  }
  #endif
  #ifndef ENV_FSUPPD
  if ((recv!=lastRecv) || (supp!=lastSupp))
  {
     sprintf(message,"Connections: %d / %d",recv,supp);
     SendMessage(hState,SB_SETTEXT,1,(LPARAM)message);
     recv=lastRecv;
     supp=lastSupp;
  }
  #endif
 #endif
#endif

if (lastRunning!=running)
   {
   if (running) SendMessage(hState,SB_SETTEXT,0,(LPARAM)"Running..." );
   else SendMessage(hState,SB_SETTEXT,0,(LPARAM)"Stopped" );
   lastRunning=running;
   }
if (PeekMessage(&IMsg,NULL,0,0,PM_REMOVE))
   {
   TranslateMessage(&IMsg);
   DispatchMessage(&IMsg);
   }
return leave;
}



void FontInitialize (HWND hwndEdit)
{
LOGFONT logfont;
HFONT   hFont;

GetObject(GetStockObject(DEFAULT_GUI_FONT/*SYSTEM_FONT*/), sizeof (LOGFONT),(PTSTR) &logfont) ;
hFont=CreateFontIndirect (&logfont) ;
SendMessage (hwndEdit, WM_SETFONT, (WPARAM) hFont, 0) ;
}



int initApplication(HINSTANCE hInst)
{
ATOM     wAtom;
WNDCLASS wc;
char     emessage[300];
int      statwidths[] = {80, 250,-1};

wc.style	 = CS_HREDRAW | CS_VREDRAW;	/* Repaint bei Fensterg�en�derung */
wc.lpfnWndProc	 = MainWndProc;					/* Nachrichtenbearbeitungs Funktion */
wc.cbClsExtra	 = 0;
wc.cbWndExtra	 = 0;
wc.hInstance	 = hInst;				/* Programm ID (Parameter von WinMain)*/
/*#ifndef ENV_FPEERD
wc.hIcon     	 = LoadIcon(hInst,ID_ICON);
#else
wc.hIcon     	 = LoadIcon(hInst,"ID_ICON");
#endif*/
wc.hCursor	 = LoadCursor(NULL, IDC_ARROW);
wc.hbrBackground= (HBRUSH)COLOR_BACKGROUND;
wc.lpszMenuName = NULL;
wc.lpszClassName= FCOMMON_NAME;
wAtom=RegisterClass(&wc);									/* Fensterklasse anmelden */
if (!wAtom)
   {
   sprintf(emessage,"Can't register window class, running in background!\n(Error code %d)",GetLastError());
   MessageBox(NULL,emessage,FCOMMON_NAME,MB_OK | MB_ICONERROR|MB_SYSTEMMODAL);
   return FCERR_GUI_CANT_REGISTER_CLASS;
   }
MyWindow=CreateWindowEx(WS_EX_OVERLAPPEDWINDOW,FCOMMON_NAME,FCOMMON_NAME,WS_OVERLAPPEDWINDOW,15,YOFFSET,WIN_WIDTH,WIN_HEIGHT,NULL,NULL,hInst,NULL);
if (!MyWindow)
   {
   sprintf(emessage,"Can't open logwindow, running in background!\n(Error code %d)",GetLastError());
   MessageBox(NULL,emessage,FCOMMON_NAME,MB_OK | MB_ICONERROR|MB_SYSTEMMODAL);
   UnregisterClass(FCOMMON_NAME,hInst);
   return FCERR_GUI_CANT_OPEN_WINDOW;
   }
LogMemA=(char*)malloc(LOGMEML);
if (!LogMemA)
   {
   MessageBox(MyWindow,"Not enough memory for log view available, running in background!",FCOMMON_NAME,MB_OK | MB_ICONERROR | MB_SYSTEMMODAL);
   UnregisterClass(FCOMMON_NAME,hInst);
   return FCERR_NO_MEMORY;
   }
LogPtr=LogMemA;
LogHnd=CreateWindowEx(WS_EX_CLIENTEDGE,"edit","",WS_VISIBLE | WS_CHILD | ES_MULTILINE | ES_AUTOHSCROLL | ES_AUTOVSCROLL,
                      0,0,400,300,
                      MyWindow,NULL,hInst,NULL);
FontInitialize(LogHnd);
if (!LogHnd)
   {
   sprintf(emessage,"Can't open log, running in background!\n(Error code %d)",GetLastError());
   MessageBox(NULL,emessage,FCOMMON_NAME,MB_OK | MB_ICONERROR|MB_SYSTEMMODAL);
   UnregisterClass(FCOMMON_NAME,hInst);
   return FCERR_GUI_CANT_OPEN_WINDOW;
   }
LoadLibrary("comctl32.dll");
hState=CreateWindowEx(0,STATUSCLASSNAME,"",WS_CHILD | WS_VISIBLE |SBARS_SIZEGRIP,
                      0, 0, 0, 0,
                      MyWindow,NULL/*(HMENU)IDC_STATE*/,hInst,NULL);
if (!hState)
   {
   sprintf(emessage,"Can't open state bar!\n(Error code %d)",GetLastError());
   MessageBox(NULL,emessage,FCOMMON_NAME,MB_OK | MB_ICONERROR|MB_SYSTEMMODAL);
   }
SendMessage(hState,SB_SETPARTS,sizeof(statwidths)/sizeof(int),(LPARAM)statwidths );

ShowWindow(MyWindow, SW_SHOWNORMAL);
UpdateWindow(MyWindow);
PlaceControls();
return 0;
}

#else // !ENV_STREAMPEER

void showLog(FILE *FHandle,char *format,...)
{
}

#endif


#else // ENV_WINDOWS


#ifndef ENV_QNX
 #include <sys/signal.h>
#else
 #include <netdb.h>
#endif
#include <signal.h>
#include <errno.h>
#include <pthread.h>


bool                  reloadSignal=false;
static char           quit=false;
static pthread_attr_t attr;

bool startThread(void* func(void*),void *arg,FILE *logHandle)
{
pthread_t            *thread;
int                   r;

errno=0;
thread=(pthread_t*)malloc(sizeof(pthread_t));
if (!thread)
   {
   showLog(logHandle,"Error: could not allocate thread (%d)",errno);
   return false;
   }
//r=pthread_attr_init(&attr);
//r=pthread_attr_setdetachstate(&attr, PTHREAD_CREATE_DETACHED);
r = pthread_create(thread,&attr,func,arg);
//pthread_attr_destroy(&attr);
if (r!=0)
   {
   showLog(logHandle,"Error: could not create thread (%d)",r);
   return false;
   }
return true;

/*pthread_t     *thread; 
int            r; 
  
thread=(pthread_t*)malloc(sizeof(pthread_t));
if (!thread)
   {
   showLog(logHandle,"Error: could not allocate thread (%d)",errno);
   return false;
   }
r=pthread_create(thread,&attr,func,arg);
if (r==-1)
   {
   showLog(logHandle,"Error: could not create thread (%d)",r);
   return false;
   }
return true;
*/

}



void signalh (const int sig)
{
//  setup_signal_traps ();
switch (sig) 
   {
   case EPIPE:
      printf("EPIPE received\n");
      break;
   case SIGHUP:
      reloadSignal=true;
      break;
   case SIGBUS:
   case SIGFPE:
   case SIGIO:
   case SIGTERM:
//      quit=1;
//      break;
   case SIGINT:
   case SIGQUIT:
      printf ("\nexiting %s\n", FCOMMON_NAME);
      quit=1;
      break;
   }
}



static void setupSignalTraps ()
{
signal (SIGINT, signalh);
signal (SIGQUIT, signalh);
signal (SIGFPE, signalh);
signal (SIGBUS, signalh);
signal (SIGTERM, signalh);
signal (SIGHUP, signalh);
signal (SIGIO, signalh);
#ifdef ENV_SPARCSOLARIS
signal (EPIPE, signalh);
signal (SIGPIPE, SIG_IGN);
#else
signal (SIGPIPE, signalh);
#endif
}




int initApplication(HINSTANCE hInst)
{
setupSignalTraps();

pthread_attr_init(&attr);
pthread_attr_setdetachstate(&attr, PTHREAD_CREATE_DETACHED);
return 0;
}


int LeaveServer(int recv, int supp,int allseconds,char running)
{
   if (quit)
   {
      pthread_attr_destroy(&attr);
   }
   return quit;
}



void showLog(FILE *FHandle,char *format,...)
{
va_list  arglist;
char     sText[1500];

va_start(arglist,format);
vsprintf(sText,format,arglist);
va_end(arglist);
sText[strlen(sText)]='\0';
if (sText[strlen(sText)-1]=='\n') sText[strlen(sText)-1]='\0';
printf("%s\n",sText);
if (FHandle) fprintf(FHandle,"%s\n",sText);
}

#endif

#ifdef ENV_SPARCSOLARIS

#include<dirent.h>
#include<stdlib.h>
#include<string.h>
#include<sys/types.h>

unsigned short swap16(unsigned short in)
{
unsigned short out;

swab((char*)&in,(char*)&out,2);
return out;
}



unsigned long swap32(unsigned long in)
{
unsigned char *a,*b;
unsigned char x;
unsigned long out;

out=in;

a=(char*)&out;
b=(char*)&out; b+=3;
x=*a; *a=*b; *b=x;

a=(char*)&out; a++;
b=(char*)&out; b+=2;
x=*a; *a=*b; *b=x;
return out;
}



unsigned long long swap64(unsigned long long in)
{
unsigned long long out;

out=(unsigned long long)swap32((unsigned long)((in & 0xFFFFFFFF00000000LL)>>32));
out=out|(((unsigned long long)swap32((unsigned long)(in & 0xFFFFFFFF)))<<32);
return out;
}


#endif

#ifdef ENV_SPARCSOLARIS
#define SET_ALPHAsort
#endif

#ifdef ENV_WINDOWS
#define SET_ALPHAsort
#endif

#ifdef SET_ALPHAsort



#ifndef ENV_FPEERD
#ifndef ENV_STREAMPEER
#ifndef ENV_LSERVED
int scandir(const char *dir, struct dirent ***namelist,
            int (*select)(const struct dirent *),
            #ifndef ENV_WINDOWS
            int (*compar)(const struct dirent **, const struct dirent **)
            #else
            int (*compar)(const void*, const void*)
            #endif
            )
{
  DIR *d;
  struct dirent *entry;
  register int i=0;
  size_t entrysize;

  if ((d=opendir(dir)) == NULL)
     return(-1);

  *namelist=NULL;
  while ((entry=readdir(d)) != NULL)
  {
    if (select == NULL || (select != NULL && (*select)(entry)))
    {
      *namelist=(struct dirent **)realloc((void *)(*namelist),
                 (size_t)((i+1)*sizeof(struct dirent *)));
if (*namelist == NULL) return(-1);
entrysize=sizeof(struct dirent)-sizeof(entry->d_name)+strlen(entry->d_name)+1;
(*namelist)[i]=(struct dirent *)malloc(entrysize);
if ((*namelist)[i] == NULL) return(-1);
memcpy((*namelist)[i], entry, entrysize);
i++;
    }
  }
  if (closedir(d)) return(-1);
  if (i == 0) return(-1);
  if (compar != NULL)
    qsort((void *)(*namelist), (size_t)i, sizeof(struct dirent *), compar);

  return(i);
}



int alphasort(const struct dirent **a, const struct dirent **b)
{
  return(strcmp((*a)->d_name, (*b)->d_name));
}
#endif
#endif
#endif

#endif

