/*
 * Copyright (c) 2004-2009 VWP
 */

#ifndef PLATFORMS_H
#define PLATFORMS_H


#ifdef ENV_WINDOWS
 #include <windows.h>

 #define MSG_NOSIGNAL 0
#endif

#ifdef ENV_LINUX
typedef void* HINSTANCE;

extern bool reloadSignal;
#endif

#ifdef ENV_QNX
typedef void* HINSTANCE;

extern bool reloadSignal;
#endif

#ifdef ENV_SPARCSOLARIS
#include<dirent.h>
#include<stdlib.h>
#include<string.h>
#include<sys/types.h>

typedef void* HINSTANCE;

extern unsigned short swap16(unsigned short in);
extern unsigned long swap32(unsigned long in);
extern unsigned long long swap64(unsigned long long in);
extern int scandir(const char *dir, struct dirent ***namelist,
            int (*select)(const struct dirent *),
            int (*compar)(const struct dirent **, const struct dirent **));
#endif

#ifndef ENV_LINUX
#ifndef ENV_QNX
extern int alphasort(const struct dirent **a, const struct dirent **b);
#endif
#endif

#ifdef ENV_WINDOWS
extern int inet_aton(const char *cp, struct in_addr *inp);
extern int asprintf (char **str, const char *fmt, ...);
extern char *strndup(const char *s,size_t n);
#endif

extern int initApplication(HINSTANCE hInst);
extern int LeaveServer(int recv, int supp,int allseconds,char running);
extern void showLog(FILE *FHandle,char *format,...);
extern bool startThread(void* func(void*),void* arg,FILE *logHandle);

#endif // PLATFORMS_H
