/*
 * Copyright (c) 2004-2009 by VWP
 */

#include "maindefs.h"

#include <stddef.h>
#include <stdlib.h>
#include <string.h>
#include <sys/types.h>

#ifdef ENV_WINDOWS
 #include <windows.h>
#else
 #include <strings.h>
 #include <ctype.h>
#endif



char *strnstr(const char *big, const char *little,unsigned long max)
{
size_t ll;

if( ((const char *)0 == big) || ((const char *)0 == little) ) return (char *)0;
if( ((char)0 == *big) || ((char)0 == *little) ) return (char *)0;

ll = strlen(little);
if( ll > (size_t)max ) return (char *)0;
max -=(unsigned long)ll;
max++;

for( ; max && *big; big++, max-- )
    if( *little == *big )
        if( 0 == strncmp(big, little, ll) )
            return (char *)big;

return (char *)0;
}



void strfreev (char **str_array)
{
if (str_array)
   {
   int i;

   for(i = 0; str_array[i] != NULL; i++) free(str_array[i]);
   free (str_array);
   }
}



/*
char* basename(char *file_name)
{
#ifdef ENV_WIN
#define DIR_SEPARATOR '\\'
#endif
#ifdef ENV_LINUX
#define DIR_SEPARATOR '/'
#endif
register char *base;
  
if (!file_name) return NULL;
base = strrchr (file_name,DIR_SEPARATOR);
#ifdef ENV_WIN
{
char *q = strrchr (file_name, '/');
if (base == NULL || (q != NULL && q > base)) base = q;
}
#endif
if (base) return base + 1;
#ifdef ENV_WIN
if (ascii_isalpha (file_name[0]) && file_name[1] == ':') return (char*) file_name + 2;
#endif
return file_name;
}
*/



char** strsplit (const char *string,const char *delimiter,int max_tokens)
{
#define MAX_TOKENS 100

char          *string_list[MAX_TOKENS];
char         **str_array;
char          *s;
unsigned int   n = 0,string_list_ctr=0;
const char    *reminder;

if (!string) return NULL;
if (!delimiter) return NULL;
if (delimiter[0]=='\0') return NULL;
if ((max_tokens<1) || (max_tokens>MAX_TOKENS)) max_tokens=MAX_TOKENS;
reminder = string;
s = strstr (reminder, delimiter);
if (s)
   {
   int delimiter_len = strlen (delimiter);   
   while (--max_tokens && s && (string_list_ctr<MAX_TOKENS-1))
      {
      int  len;     
      char *new_string;

      len = s - reminder;
      new_string=malloc(len+1); 
      if (!new_string) return NULL;
      strncpy (new_string, reminder, len);
      new_string[len] = 0;
      string_list[string_list_ctr]=new_string;
      string_list_ctr++;
      n++;
      reminder = s + delimiter_len;
      s = strstr (reminder, delimiter);
      }
   }
if (*string)
   {
   n++;
   string_list[string_list_ctr]=strdup(reminder);
   string_list_ctr++;
   }

str_array=malloc(sizeof(char*)*(n + 1));
if (!str_array) return NULL;
str_array[n--] = NULL;
for (n=0; n<string_list_ctr; n++) str_array[n]=strdup(string_list[n]);
return str_array;
}



void strup(char *string)
{
register unsigned char *s;

if (!string) return;
s=(unsigned char*) string;
while (*s)
   {
   /*if (islower (*s))*/ *s=toupper(*s);
   s++;
   }
}


