/*
 * Copyright (c) 2004-2009 by VWP
 */

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <time.h>

#ifdef ENV_WINDOWS
 #include <windows.h>
 #include <dos.h>
#else
 #include <strings.h>
 #include <unistd.h>
 #include <sys/time.h>
#ifdef ENV_QNX
 #include <errno.h>
#else
 #include <sys/errno.h>
#endif
 #include <sys/types.h>
 #include <ctype.h>
#endif

#include "maindefs.h"
#include "platforms.h"
#include "util.h"
#ifndef ENV_FNODED
#ifndef ENV_FCTERM
#ifndef ENV_STREAMPEER
#include "strutils.h"
#endif
#endif
#endif

#ifdef ENV_WINDOWS
#define inline
#endif


int ThreadSleep(int msecs)
{
#ifdef ENV_WINDOWS
Sleep(msecs);
#else
usleep(msecs*1000);
#endif
return msecs;
}



#ifndef ENV_FCTERM
#ifndef ENV_FLYENCD

static char base64table[64] = {
    'A','B','C','D','E','F','G','H','I','J','K','L','M','N','O','P',
    'Q','R','S','T','U','V','W','X','Y','Z','a','b','c','d','e','f',
    'g','h','i','j','k','l','m','n','o','p','q','r','s','t','u','v',
    'w','x','y','z','0','1','2','3','4','5','6','7','8','9','+','/'};



char *base64Encode(char *data)
{
int len = strlen(data);
char *out =(char*)malloc(len*4/3 + 4);
char *result = out;
int chunk;

while(len > 0) 
   {
   chunk = (len >3)?3:len;
   *out++ = base64table[(*data & 0xFC)>>2];
   *out++ = base64table[((*data & 0x03)<<4) | ((*(data+1) & 0xF0) >> 4)];
   switch(chunk) 
      {
      case 3:
         *out++ = base64table[((*(data+1) & 0x0F)<<2) | ((*(data+2) & 0xC0)>>6)];
         *out++ = base64table[(*(data+2)) & 0x3F];
         break;
      case 2:
         *out++ = base64table[((*(data+1) & 0x0F)<<2)];
         *out++ = '=';
         break;
      case 1:
         *out++ = '=';
         *out++ = '=';
         break;
      }
   data += chunk;
   len -= chunk;
   }
*out = 0;
return result;
}



static char base64decode[256] = {
     -2, -2, -2, -2, -2, -2, -2, -2, -2, -2, -2, -2, -2, -2, -2, -2,
     -2, -2, -2, -2, -2, -2, -2, -2, -2, -2, -2, -2, -2, -2, -2, -2,
     -2, -2, -2, -2, -2, -2, -2, -2, -2, -2, -2, 62, -2, -2, -2, 63,
     52, 53, 54, 55, 56, 57, 58, 59, 60, 61, -2, -2, -2, -1, -2, -2,
     -2,  0,  1,  2,  3,  4,  5,  6,  7,  8,  9, 10, 11, 12, 13, 14,
     15, 16, 17, 18, 19, 20, 21, 22, 23, 24, 25, -2, -2, -2, -2, -2,
     -2, 26, 27, 28, 29, 30, 31, 32, 33, 34, 35, 36, 37, 38, 39, 40,
     41, 42, 43, 44, 45, 46, 47, 48, 49, 50, 51, -2, -2, -2, -2, -2,
     -2, -2, -2, -2, -2, -2, -2, -2, -2, -2, -2, -2, -2, -2, -2, -2,
     -2, -2, -2, -2, -2, -2, -2, -2, -2, -2, -2, -2, -2, -2, -2, -2,
     -2, -2, -2, -2, -2, -2, -2, -2, -2, -2, -2, -2, -2, -2, -2, -2,
     -2, -2, -2, -2, -2, -2, -2, -2, -2, -2, -2, -2, -2, -2, -2, -2,
     -2, -2, -2, -2, -2, -2, -2, -2, -2, -2, -2, -2, -2, -2, -2, -2,
     -2, -2, -2, -2, -2, -2, -2, -2, -2, -2, -2, -2, -2, -2, -2, -2,
     -2, -2, -2, -2, -2, -2, -2, -2, -2, -2, -2, -2, -2, -2, -2, -2,
     -2, -2, -2, -2, -2, -2, -2, -2, -2, -2, -2, -2, -2, -2, -2, -2
};


char *base64Decode(char *input,long maxlen)
{
int   len = strlen(input);
char *out =(char*)malloc(len*3/4 + 5);
char *result = out,*sPos;
char  vals[4];

sPos=input;
while ((len > 0) && (input-sPos<maxlen))
   {
   if(len < 4)
      {
      free(result);
      return NULL;
      }

   vals[0] = base64decode[(unsigned char)*input]; input++;
   vals[1] = base64decode[(unsigned char)*input]; input++;
   vals[2] = base64decode[(unsigned char)*input]; input++;
   vals[3] = base64decode[(unsigned char)*input]; input++;

   if(vals[0] < 0 || vals[1] < 0 || vals[2] < -1 || vals[3] < -1) 
      {
      len -= 4;
      continue;
      }

   *out++ = vals[0]<<2 | vals[1]>>4;
   if(vals[2] >= 0) *out++ = ((vals[1]&0x0F)<<4) | (vals[2]>>2);
   else *out++ = 0;

   if(vals[3] >= 0) *out++ = ((vals[2]&0x03)<<6) | (vals[3]);
   else *out++ = 0;

   len -= 4;
   }
*out = 0;
return result;
}


#ifndef ENV_FNODED
#ifndef ENV_STREAMPEER

char **readFilelist(char *name)
{
char  *filelist;
size_t plsize,read_size=0;
FILE  *fil;
char **ret = NULL;

if (name != NULL)
   {
   fil = fopen (name, "r");
   if (fil!=NULL)
      {
      fseek(fil,0,SEEK_END);
      plsize=ftell(fil);
      fseek(fil,0,SEEK_SET);
      filelist =(char*)malloc (plsize + 1);
      if (!filelist)
         {
         showLog(NULL,"Not enough memory for list \"%s\"!\n",name);
         fclose(fil);
         return NULL;
         }
      read_size=fread(filelist,1,plsize,fil);
      if (read_size>0)
         {
         filelist[read_size + 1] = '\0';
         ret = strsplit (filelist, "\n", 0);
         free (filelist);
         }
      else
         {
         perror("");
         showLog(NULL,"List file \"%s\" read error\n",name);
         printf("%ld %ld\n",(long)plsize,(long)read_size);
         free(filelist);
         }
      fclose (fil);
      }
   else
      {
      perror("");
      showLog(NULL,"Can't open list file \"%s\"\n",name);
      }
   }
return ret;
}

#endif
#endif
#endif
#endif


#ifdef ENV_WINDOWS
void gettimeofday(struct timeval *unixt,void *foo)
{
/*struct time dost;
gettime(&dost);*/
unixt->tv_sec=time(NULL);//dost.ti_sec;
unixt->tv_usec=0;
}
#endif



#ifndef ENV_FPEERD
long getCRC(char *ptr, int len)
{
long crc,val,bit;

for (crc=~0; len--;) 
   {
   val = (unsigned long)(*ptr++) << 8;    /* read one byte */
   for (bit=8; bit--; ) 
      {        /* for all bits */
      if ((crc^val) & 0x8000000)
         {
         crc^=0x7353;      /* CRC2POLYNOM */
         crc<<=1;
         crc|=0x0001;
         }
      else crc <<= 1;
      val <<= 1;          /* shift to next bit */
      }
   }
return(crc);
}



inline void resettimeout (struct timeval *tv)
{
tv->tv_sec = 0;
tv->tv_usec = 5;
}



#ifndef ENV_FCTERM

static char hexchars[] = "0123456789ABCDEF";



int urlparse (char *url, char **protocol, char **host, char **port, char **location)
{
char *tmp, *tmpurl;
int itmp;
char *tprotocol=NULL, *thost=NULL, *tport=NULL, *tlocation=NULL;

if (NULL != url)
   {
   tmpurl = url;
   tmp = strstr (tmpurl, "://");
   if ((NULL != tmp) && (tmp != tmpurl))
      {
      itmp = tmp - tmpurl;
      tprotocol =(char*)malloc (itmp + 1);
      memcpy (tprotocol, tmpurl, itmp);
      tprotocol[itmp] = 0;
      tmpurl += itmp + 3;
      tmp = strchr (tmpurl, '/');
      if (NULL != tmp)
         {
         itmp = strlen (tmpurl) - (tmp - tmpurl);
         tlocation =(char*)malloc (itmp + 1);
         memcpy (tlocation, tmp, itmp);
         tlocation[itmp] = 0;
         itmp = tmp - tmpurl;
         tmp =(char*)malloc (itmp + 1);
         memcpy (tmp, tmpurl, itmp);
         tmp[itmp] = 0;
         tmpurl = tmp;
         }
      else tlocation = strdup ("/");
      tmp = strchr (tmpurl, ':');
      if (NULL != tmp)
         {
         itmp = strlen (tmpurl) - (tmp - tmpurl);
         tport =(char*)malloc (itmp);
         memcpy (tport, tmp + 1, itmp - 1);
         tport[itmp - 1] = 0;
         itmp = tmp - tmpurl;
         thost=(char*)malloc (itmp + 1);
         memcpy (thost, tmpurl, itmp);
         thost[itmp] = 0;
         }
      else
         {
         tport = strdup ("8000");
         thost = strdup (tmpurl);
         }
      free (tmpurl);
      }
   *protocol = tprotocol;
   *host = thost;
   *port = tport;
   *location = tlocation;
   return 1;
   }
return 0;
}



// TODO: replace this function
char *getHeader(char *hname, char *headers)
{
char *t, *r;
char *header = NULL;

r = strstr(headers,hname);
if (r)
   {
   if (' ' == r[strlen (hname)]) r++;
   t = strstr (r, "\r\n");
   if (!t) t = strchr (r, '\n');
   if (t)
      {
      header =(char*)malloc (t - r - strlen (hname) + 1);
      header = strncpy (header, r + strlen (hname), t - r - strlen (hname));
      header[t - r - strlen (hname)] = '\0';
      }
   }
return header;
}



char *getheaders(char *hname, char *headers)
{
return getHeader(hname,headers);
}



char *get_data_pos (char *b, long length)
{
char *tb;
char *ret = NULL;
int   diff = 0;

tb = strnstr(b, "\r\n\r\n",length);
if (NULL == tb)
   {
   tb = strnstr (b, "\n\n",length);
   diff = 2;
   }
else diff = 4;
if (tb) ret = b + (tb - b) + diff;
return ret;
}



char *urlencode (char * s)
{
int x, y, len;
char *str;

len = strlen (s);
str =(char*)malloc (sizeof (char) * (3 * len + 1));
for (x = 0, y = 0; len--; x++, y++) 
   {
   str[y] = s[x];
   if (' ' == str[y]) str[y] = '+';
   else if ((str[y] < '0' && str[y] != '-' && str[y] != '.') ||
            (str[y] < 'A' && str[y] > '9') ||
            (str[y] > 'Z' && str[y] < 'a' && str[y] != '_') || (str[y] > 'z')) 
      {
      str[y++] = '%';
      str[y++] = hexchars[s[x] >> 4];
      str[y] = hexchars[s[x] & 15];
      }
   }
str[y] = '\0';
return (str);
}
#endif


#ifdef ENV_WINDOWS

#ifdef ENV_FSUPPD

int strcasecmp (const char *s1,const char *s2)
{
const unsigned char *p1 = (const unsigned char *) s1;
const unsigned char *p2 = (const unsigned char *) s2;
int result;

if (p1 == p2) return 0;

while ((result = tolower(*p1) - tolower(*p2++)) == 0)
 if (*p1++ == '\0') break;
return result;
}

#endif
#endif



char *memfind (char * what,char * block, size_t len, int l)
{
char *ret = NULL;
size_t i;

if (l <= len)
   {
   i = 0;
   while ((NULL == ret) && (i < len - 1 - l)) 
      {
      if (!memcmp (what, block + i, l)) ret = block + i;
      i++;
      }
   }
return ret;
}



#ifndef ENV_FSUPPD

#define NUM_SIZES 4
static char *const sizes[NUM_SIZES] = { "B", "K", "M", "G" };



char *getHeaderValue(char *hname,char *headers)
{
char *t, *r;

r = strstr (headers, hname);
if (r)
   {
   if (r[strlen (hname)]==' ') r++;
   t = strstr (r, "\r\n");
   if (!t) t=strchr(r,'\n');
   if (t) return (r+strlen(hname));
  }
return NULL;
}



char *getparameter (char *req, char *pname)
{
char *t, *t2, *r;
char *par = NULL;
char *c;

r = strstr (req, pname);
if (r)
   {
   t = strstr (r, " ");
   t2 = strstr (r, "&");
   if (t2 != NULL)
      {
      if (t != NULL)
         {
	 if (t2 < t) t = t2;
	 }
      else t = t2;
      }
   if (t != NULL)
      {
      par =(char*)malloc (t - r - strlen (pname) + 1);
      par = strncpy (par, r + strlen (pname), t - r - strlen (pname));
      par[t - r - strlen (pname)] = '\0';
      c=par;
      while (*c!='\0')
         {
         if (*c=='\1') *c=' ';
         c++;
         }
     }
  return par;
  }
else return NULL;
}



char *urldecode (char *str)
{
char *dest = str,*data = str;
char  val[3];
int   len;

val[2]='\0';
if (!str) return NULL;
len = strlen (str);
while (len--)
   {
   if ('+' == *data) *dest = ' ';
   else
      {
      if ('%' == *data && len >= 2 && isxdigit ((int) * (data + 1)) && isxdigit ((int) * (data + 2)))
         {
         val[0]=*(data+1);
         val[1]=*(data+2);
         *dest=(char)strtol(val,NULL,16);
	 data +=2;
	 len -= 2;
         }
      else *dest = *data;
      }
   data++;
   dest++;
   }
*dest = '\0';
return str;
}



extern float convert_size (u_long bytes, char **code)
{
float ret;
int   i;

ret=bytes;
i=0;
while ((i<NUM_SIZES)&&(ret>999.9))
   {
   ret=ret/1024;
   i++;
   }
if (i>=NUM_SIZES) i=NUM_SIZES-1;
*code=sizes[i];
return ret;
}



#endif
#endif

#ifndef ENV_FCASTD
#ifndef ENV_FCTERM

char *strdupSpaceEscape(char *in)
{
char *out,*c;
char  startEscape=false;

out=strdup(in);
c=out;
while (*c!='\0')
   {
   if (*c=='?') startEscape=true;
   else if ((startEscape) && (*c==' ')) *c='\1';
   c++;
   }
return out;
}

#endif
#endif

#ifdef ENV_FCASTD

void spaceDeescape(char *in)
{
char *c;

c=in;
while (*c!='\0')
   {
   if (*c=='\1') *c=' ';
   c++;
   }
}

#endif

