package base;

import javax.swing.*;
import java.awt.*;

import com.vwp.swing.*;




@SuppressWarnings("serial")
public class BottomField extends JPanel
{
   private JLabel       track=new JLabel(),artist=new JLabel(),album=new JLabel(),
                        time=new JLabel(),info=new JLabel();
   private JButton      cover=new JButton();
   private XProgressBar progress=new XProgressBar(0,60000,XProgressBar.MODE_TIME);
   private int          lastTrackNum=-1,displayedInfo=0;
   private long         lastDisplaySwitch=0;
   private String       trackNum,lcdText1="",lcdText2="";
   private boolean      lockHidePanel=false;

   public BottomField()
   {
      setBackground(new Color(45,45,75));
      track.setForeground(Color.WHITE);
      track.setFont(new Font("",Font.PLAIN,25));
      artist.setForeground(Color.LIGHT_GRAY);
      album.setForeground(Color.LIGHT_GRAY);
      time.setForeground(Color.WHITE);
      info.setForeground(Color.LIGHT_GRAY);
      cover.setMargin(new Insets(0,0,0,0));
      cover.setBorder(null);
      setLayout(new GridBagLayout());
      progress.setForeground(new Color(0,0,138));
//      progress.setPreferredSize(new Dimension(100,25));
      
      
      add(artist,new GridBagConstraints(0, 0, 1, 1, 0.9, 0.0
            ,GridBagConstraints.CENTER, GridBagConstraints.NONE, new Insets(1,10,1,1), 0, 0));
      add(album,new GridBagConstraints(0, 1, 1, 1, 0.9, 0.0
            ,GridBagConstraints.CENTER, GridBagConstraints.NONE, new Insets(1,10,1,1), 0, 0));
      add(track,new GridBagConstraints(0, 2, 1, 1, 0.0, 0.0
            ,GridBagConstraints.CENTER, GridBagConstraints.NONE, new Insets(1,10,1,1), 0, 0));
      add(progress,new GridBagConstraints(0, 3, 1, 1, 0.0, 0.1
            ,GridBagConstraints.CENTER, GridBagConstraints.BOTH, new Insets(1,15,1,10), 0, 0));
      add(time,new GridBagConstraints(0, 4, 1, 1, 0.0, 0.0
            ,GridBagConstraints.CENTER, GridBagConstraints.NONE, new Insets(1,10,1,1), 0, 0));
      add(info,new GridBagConstraints(0, 5, 1, 1, 0.0, 0.0
            ,GridBagConstraints.CENTER, GridBagConstraints.NONE, new Insets(1,10,1,1), 0, 0));
      add(new JLabel(),new GridBagConstraints(0, 6, 1, 1, 0.0, 0.1
            ,GridBagConstraints.CENTER, GridBagConstraints.NONE, new Insets(0,0,0,0), 0, 0));
      
      add(cover,new GridBagConstraints(1, 0, 1, 7, 0.0, 0.0
            ,GridBagConstraints.NORTHWEST, GridBagConstraints.NONE, new Insets(1, 1, 7, 10), 0, 0));

      hidePanel("BottomField()");
   }

   
   
   public void setLockHidePanel(boolean lockHidePanel)
   {
      this.lockHidePanel=lockHidePanel;
   }
   
   
   
   public void hidePanel(String src)
   {
//System.out.println(src);      
      if (!lockHidePanel) 
      {
         if (PoddyFrame.MyWin!=null) PoddyFrame.MyWin.setLCDText(lcdText1,lcdText2);
         setVisible(false);
      }
      progress.stop();
      progress.setValue(0);
      lastTrackNum=-1;
   }
   
   
   
   public void setPlayInfo(CDInfo cdInfo,TrackInfo trackInfo)
   {
      int min,sec;
      
      if (lastTrackNum!=trackInfo.trackNum)
      {
         Image img;

         artist.setText(cdInfo.artist);
         album.setText(cdInfo.album);
         track.setText(trackInfo.name.substring(5));
         trackNum=trackInfo.name.substring(0,2);
         info.setText(cdInfo.year+", "+cdInfo.genre);
         lastTrackNum=trackInfo.trackNum;
         progress.setValue(0);
         progress.setMaximum(trackInfo.trackTime*1000L);
         progress.restart();
         
         img=Toolkit.getDefaultToolkit().createImage(cdInfo.getAlbumDir()+"/image.png");
         cover.setIcon(new ImageIcon(img));
/*         revalidate();
         if (MainWin.MyWin!=null)
         {
            MainWin.MyWin.validate();
            MainWin.MyWin.repaint();
         }*/
         lcdText1=PoddyFrame.MyWin.getLCDText(1);
         lcdText2=PoddyFrame.MyWin.getLCDText(2);
         PoddyFrame.MyWin.setLCDText(track.getText(),artist.getText());
         displayedInfo=0;
         lastDisplaySwitch=System.currentTimeMillis();
         setVisible(true);
//         PoddyFrame.MyWin.mainPanel.revalidate();
      }

      min=trackInfo.currentTrackTime/60;
      sec=trackInfo.currentTrackTime-(min*60);
      if (sec<10) time.setText(trackNum+" - "+min+":0"+sec);
      else time.setText(trackNum+" - "+min+":"+sec);      
      progress.setValue(trackInfo.currentTrackTime*1000);
      if (lastDisplaySwitch+6500<System.currentTimeMillis())
      {
         displayedInfo++;
         if (displayedInfo>3) displayedInfo=0;
         switch (displayedInfo)
         {
         case 0:
            PoddyFrame.MyWin.setLCDText(null,artist.getText());
            break;
         case 1:
            PoddyFrame.MyWin.setLCDText(null,album.getText());
            break;
         case 2:
            PoddyFrame.MyWin.setLCDText(null,info.getText());
            break;
         default:
            break;
         }
         lastDisplaySwitch=System.currentTimeMillis();
      }
      if (displayedInfo==3)
      {
         min=trackInfo.trackTime/60;
         sec=trackInfo.trackTime-(min*60);
         if (sec<10) PoddyFrame.MyWin.setLCDText(null,time.getText()+" / "+min+":0"+sec);
         else PoddyFrame.MyWin.setLCDText(null,time.getText()+" / "+min+":"+sec);
      }
   }
}
