/**
 * 
 */

package base;

import java.io.*;
import java.util.*;
import javax.sound.sampled.*;

import org.kc7bfi.jflac.*;
import org.kc7bfi.jflac.frame.*;
import org.kc7bfi.jflac.metadata.*;
import org.kc7bfi.jflac.util.*;




public class CDPlay extends Thread implements PCMProcessor
   {
 
   private String    filename=null,dirname=null;
   private String    filenames[];
   private boolean   play=true,playLeft=false,CDDBUpdated=false;
   private TrackInfo trackInfo;
   private CDInfo    cdInfo;
           boolean   isPlaying=true,turnOffBottomPanelAtEnd=false;
 
   private AudioFormat fmt;
   private DataLine.Info info;
   private SourceDataLine line=null;
   private Vector<LineListener> listeners = new Vector<LineListener>();
   private FLACDecoder          decoder;
   private aSymFrameListener    myFrameList=new aSymFrameListener();
   private FileInputStream      is;
//   private static final int JUMP_NEXT_TITLE=1,JUMP_PREV_TITLE=2;
   private int              /*titleJumpMode=0,*/startPos=0;
   private PlayInfoUpdater  playInfoUpdater=new PlayInfoUpdater();
//   private FloatControl     volumeControl=null;    
   
   
   class PlayInfoUpdater extends Thread
   {
      private long          lastTimeInfo=System.currentTimeMillis();
      private Vector<Frame> frameList=new Vector<Frame>();
      boolean               doRun=true;

      PlayInfoUpdater()
      {
         start();
      }
      
      
      
      void updatePlayInfo(Frame frame)
      {
         frameList.add(frame);
      }
      
      
      
      public void run()
      {
         Frame nextFrame;
         
         while (doRun)
         {
            if (play) try
            {
               if (frameList.size()>0)
               {
                  nextFrame=frameList.elementAt(0);
                  frameList.removeElementAt(0);
               }
               else nextFrame=null;
               if ((nextFrame!=null) && (lastTimeInfo+1000<=System.currentTimeMillis()))
               {
                  lastTimeInfo=System.currentTimeMillis();
                  trackInfo.trackTime=(int)(decoder.getStreamInfo().getTotalSamples()/decoder.getStreamInfo().getSampleRate());
                  trackInfo.currentTrackTime=(int)(nextFrame.header.sampleNumber/nextFrame.header.sampleRate);
                  PoddyFrame.MyWin.setPlayInfo(cdInfo,trackInfo,"PlayInfoUpdater.run()");
                  nextFrame=null;
               }
               else if ((!CDDBUpdated) && (cdInfo!=null))
               {
                  PoddyFrame.MyWin.updateCDDBs(cdInfo.artist,cdInfo.album,trackInfo.name);
                  CDDBUpdated=true;
               }
            }
            catch (Exception e)
            {
               e.printStackTrace();
            }
            if (frameList.size()==0) com.vwp.util.Tools.threadSleep(50);
         }
      }
   }
   
  class aSymFrameListener implements FrameListener
  {
     public void processMetadata(Metadata metadata)
     {  
     }
     
     public void processFrame(Frame frame)
     {
        if (play) playInfoUpdater.updatePlayInfo(frame);
     }
     
     public void processError(String msg)
     {   
     }
     
     public void switchTrack(int trackNum)
     {
        trackInfo.name=filenames[trackNum];
        trackInfo.trackNum=trackNum;
     }
     
  }

   
   CDPlay(String wavfile,CDInfo cdInfo,TrackInfo trackInfo) 
   {
      this.filename = wavfile;
      this.trackInfo=trackInfo;
      this.cdInfo=cdInfo;
      start();
   }
   
      
   CDPlay(String dirname,String wavfiles[],CDInfo cdInfo,TrackInfo trackInfo,int startPos,boolean turnOffBottomPanelAtEnd) 
   {
      this.dirname=dirname;
      this.filenames=wavfiles;
      this.trackInfo=trackInfo;
      this.cdInfo=cdInfo;
      this.startPos=startPos;
      this.turnOffBottomPanelAtEnd=turnOffBottomPanelAtEnd;
      start();
   }
   
         
   
   void stopPlay(boolean wait,boolean stopUpdater)
   {
      play=false;
      if (stopUpdater) playInfoUpdater.doRun=false;
      try
      {
         if (decoder!=null) 
            {
            decoder.stopPlay();
            decoder.removePCMProcessor(this);
            }
         if (is!=null) is.close();
      }
      catch (Exception e)
      {
         e.printStackTrace();
      }
      if (wait) 
      {
         while (!playLeft)
         {
            com.vwp.util.Tools.threadSleep(100);
         }
//         PoddyFrame.MyWin.setPlayInfo(null,null,"CDPlay.stopPlay()");
      }
   }

   
   
   void nextTrack()
   {
      decoder.switchToNextTrack();
/*      titleJumpMode=JUMP_NEXT_TITLE;
      stopPlay(false,false);*/
   }
   
   
   
   void previousTrack()
   {
      decoder.switchToPreviousTrack();
/*      titleJumpMode=JUMP_PREV_TITLE;
      stopPlay(false,false);*/
   }
 
   
   
   int currentTrack()
   {
      return decoder.currentTrack();
   }
   
   
   
   int lastTrack()
   {
      return filenames.length;
   }
   
   
   
   public void run() 
   {
      setPriority(NORM_PRIORITY+2);
      if (filename!=null) 
      {
         if (trackInfo.trackNum==-1) trackInfo.trackNum=-2;
         try
         {
            decode(filename);
         }
         catch (Exception e)
         {
         e.printStackTrace();
         }
      }
      else
      {
         String[] pathnames=new String[filenames.length];
         
         for (int i=0; i<filenames.length; i++)
          pathnames[i]=dirname+"/"+filenames[i];
         playLeft=false;
         trackInfo.name=filenames[startPos];
         trackInfo.trackNum=startPos;
         try
         {
            decode(pathnames,startPos);
         }
         catch (Exception e)
         {
            e.printStackTrace();
         }
/*         int titleNum;
         
         titleNum=startPos;
         while (titleNum<filenames.length)
         {
            playLeft=false;
            trackInfo.name=filenames[titleNum];
            trackInfo.trackNum=titleNum;
            try
            {
               decode(dirname+"/"+filenames[titleNum]);
            }
            catch (Exception e)
            {
               e.printStackTrace();
            }
            if (titleJumpMode==JUMP_NEXT_TITLE)
            {
               play=true;
            }
            else if (titleJumpMode==JUMP_PREV_TITLE)
            {
               play=true;
               titleNum-=2;
               if (titleNum<-1) titleNum=-1;
            }
            titleJumpMode=0;
            if (!play) 
               {
               if (turnOffBottomPanelAtEnd) PoddyFrame.MyWin.turnOffBottomPanel();
               return;
               }
            titleNum++;
         }*/
         if (turnOffBottomPanelAtEnd) PoddyFrame.MyWin.turnOffBottomPanel();
      }
      PoddyFrame.MyWin.setPlayInfo(null,null,"CDPlay.run()"); 
      isPlaying=false;
   }
   


  public void addListener (LineListener listener)
  {
     listeners.add(listener);
  }

  
  
   public void decode(String inFileName) throws IOException 
   {

      playLeft=false;
      CDDBUpdated=false;
      is = new FileInputStream(inFileName);
      decoder=new FLACDecoder(is);
      decoder.addPCMProcessor(this);
      decoder.addFrameListener(myFrameList);
      try 
      {
         decoder.decode();
      } 
      catch (Exception e) 
      {
//         e.printStackTrace();
      }      
      try 
      {
         line.drain();
         line.close();
      } 
      catch (Exception e2) 
      {
//         e.printStackTrace();
      }      
      listeners.clear();
      playLeft=true;
   }

   
   
   public void decode(String[] inFileNames,int myStartPos) throws IOException 
   {

      playLeft=false;
      CDDBUpdated=false;
      decoder=new FLACDecoder(inFileNames,myStartPos);
      decoder.addPCMProcessor(this);
      decoder.addFrameListener(myFrameList);
      try 
      {
         decoder.decode();
      } 
      catch (Exception e) 
      {
         e.printStackTrace();
      }      
      line.drain();
      line.close();
      line=null;
      listeners.clear();
      playLeft=true;
   }
   
   

   public void processStreamInfo(StreamInfo streamInfo) 
   {
      if (line!=null) return;
      try 
      {
         fmt = streamInfo.getAudioFormat();
         info = new DataLine.Info(SourceDataLine.class, fmt, AudioSystem.NOT_SPECIFIED);
         line = (SourceDataLine) AudioSystem.getLine(info);

         int size = listeners.size();
         for (int index = 0; index < size; index++)
          line.addLineListener(listeners.get(index));

         line.open(fmt, AudioSystem.NOT_SPECIFIED);
         line.start();
//         volumeControl=(FloatControl)line.getControl(FloatControl.Type.MASTER_GAIN);
//         volumeControl.setValue(13);
      } 
      catch (LineUnavailableException e) 
      {
         e.printStackTrace();
      }
   }
   
   /**
    * Process the decoded PCM bytes.
    * @param pcm The decoded PCM data
    * @see org.kc7bfi.jflac.PCMProcessor#processPCM(org.kc7bfi.jflac.util.ByteSpace)
    */
   public void processPCM(ByteData pcm) 
   {
       line.write(pcm.getData(), 0, pcm.getLen());
   }
   
   

  public void removeListener (LineListener listener)
  {
     listeners.removeElement(listener);
  }


   
   
   
}
