/*
 * MediaInfo.java
 *
 * Copyright (c) 2008-2009 Virtual Worlds Productions
 * Email: virtual_worlds(at)gmx.de
 *
 * This program is free software; you can redistribute it and/or modify  it
 * under the terms of the GNU General Public License as published by the Free
 * Software Foundation
 *
 * Please contact virtual_worlds(at)gmx.de if you are interested in a source
 * package which is not licensed under the GPL
 *
 * This software is provided "AS IS," without a warranty of any kind. ALL
 * EXPRESS OR IMPLIED CONDITIONS, REPRESENTATIONS AND WARRANTIES, INCLUDING ANY
 * IMPLIED WARRANTY OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE OR
 * NON-INFRINGEMENT, ARE HEREBY EXCLUDED. VIRTUAL WORLDS PRODUCTIONS AND ITS
 * LICENSORS SHALL NOT BE LIABLE FOR ANY DAMAGES SUFFERED BY LICENSEE AS A
 * RESULT OF USING, MODIFYING OR DISTRIBUTING THE SOFTWARE OR ITS DERIVATIVES.
 * IN NO EVENT WILL VIRTUAL WORLDS PRODUCTIONS OR ITS LICENSORS BE LIABLE FOR
 * ANY LOST REVENUE, PROFIT OR DATA, OR FOR DIRECT, INDIRECT, SPECIAL,
 * CONSEQUENTIAL, INCIDENTAL OR PUNITIVE DAMAGES, HOWEVER CAUSED AND REGARDLESS
 * OF THE THEORY OF LIABILITY, ARISING OUT OF THE USE OF OR INABILITY TO USE
 * SOFTWARE, EVEN IF VIRTUAL WORLDS PRODUCTIONS HAS BEEN ADVISED OF THE
 * POSSIBILITY OF SUCH DAMAGES.
 *
 * This software is not designed or intended for use in on-line control of
 * aircraft, air traffic, aircraft navigation or aircraft communications; or in
 * the design, construction, operation or maintenance of any nuclear
 * facility. Licensee represents and warrants that it will not use or
 * redistribute the Software for such purposes.
 */



package base;

import java.io.*;


/**
 * This class handles general media inf othat do not belong to any of the other types CD or DVD.
 * It stores all information required for these general media.
 */
public class MediaInfo
{
   public String path=null,title=null;

   
   
  /**
   * This is the default constructor of this class
   */
   public MediaInfo()
   {
   }
   
   
  /**
   * The standard constructor for a new, valid MediaInfo object
   * @param path the complete path to the position where the related media file is stored at
   * @param title the title of the file
   */
   public MediaInfo(String path,String title)
   {
      File file;
      
      this.path=path;
      if (title==null)
      {
         file=new File(path);
         title=file.getName();
      }
      else this.title=title;
   }
   
   
   
  /**
   * This method sets new media information in a secure way: only these new values are set
   * that contain new values, when a member of the new info object is unused, the original
   * member variable will be left untouched
   * @param info the new MediaInfo object that has to be used to set new data
   */
   public void set(MediaInfo info)
   {
      if (info==null) return;
      if (info.path!=null) this.path=info.path; 
      if (info.title!=null) this.title=info.title; 
   }
   
}
