/*
 * SQLAccess.java
 *
 * Copyright (c) 2008-2009 Virtual Worlds Productions
 * Email: virtual_worlds(at)gmx.de
 *
 * This program is free software; you can redistribute it and/or modify  it
 * under the terms of the GNU General Public License as published by the Fre
 * Software Foundation
 *
 * Please contact virtual_worlds(at)gmx.de if you are interested in a source
 * package which is not licensed under the GPL
 *
 * This software is provided "AS IS," without a warranty of any kind. ALL
 * EXPRESS OR IMPLIED CONDITIONS, REPRESENTATIONS AND WARRANTIES, INCLUDING ANY
 * IMPLIED WARRANTY OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE OR
 * NON-INFRINGEMENT, ARE HEREBY EXCLUDED. VIRTUAL WORLDS PRODUCTIONS AND ITS
 * LICENSORS SHALL NOT BE LIABLE FOR ANY DAMAGES SUFFERED BY LICENSEE AS A
 * RESULT OF USING, MODIFYING OR DISTRIBUTING THE SOFTWARE OR ITS DERIVATIVES.
 * IN NO EVENT WILL VIRTUAL WORLDS PRODUCTIONS OR ITS LICENSORS BE LIABLE FOR
 * ANY LOST REVENUE, PROFIT OR DATA, OR FOR DIRECT, INDIRECT, SPECIAL,
 * CONSEQUENTIAL, INCIDENTAL OR PUNITIVE DAMAGES, HOWEVER CAUSED AND REGARDLESS
 * OF THE THEORY OF LIABILITY, ARISING OUT OF THE USE OF OR INABILITY TO USE
 * SOFTWARE, EVEN IF VIRTUAL WORLDS PRODUCTIONS HAS BEEN ADVISED OF THE
 * POSSIBILITY OF SUCH DAMAGES.
 *
 * This software is not designed or intended for use in on-line control of
 * aircraft, air traffic, aircraft navigation or aircraft communications; or in
 * the design, construction, operation or maintenance of any nuclear
 * facility. Licensee represents and warrants that it will not use or
 * redistribute the Software for such purposes.
 */


package base;

import java.sql.*;
import javax.swing.*;



/**
 * This is a base class for all SQL database access operations. The real implementation has to be done within
 * a class that inherits from SQLAccess.
 */
public class SQLAccess
{
   Statement                  SQLSt;
   Connection                 SQLCon=null;
   String                     DBName;
   public static final int    T_CDS=1;
   public static final int    T_CDTRACKS=2;
   public static final int    T_STATIONS=3;
   public static final int    T_DVDS=4;
   public static final int    T_SCHEDULE=5;
   public static final int    T_COUNT=6;
   public static final int    T_TEXT=7;
   public static final String CDTable="cds",CDTracksTable="cdtracks",ScheduleTable="schedule",
                              DVDTable="dvds",StationsTable="stations";  
   String                     errorText;
   boolean                    stopThread=false;
   long                       lastCmd=System.currentTimeMillis();
	           
	   	   
	   
  /**
   * Closes a JDBC connection to a database; after this method was called the database cant
   * be accessed any longer.
   */
   public void closeJDBC()
   {
   }
	   
    
    
  /**
   * Establishes a new JDBC connection; this method has to be called after object creation
   * and before the database is accessed.
   */
   public boolean initJDBC()
   {
      return false;
   }

	   
	   
  /**
   * Fetch a full list of TV stations from the database
   * @return the TV stations that have been stored within the database
   */
   public DefaultListModel loadStations()
   {
      return null;
   }
	
    
  /**
   * This method deletes a possibly existing list of TV stations out of the database
   * and stores the new one
   * @param list the new list of TV stations to be saved
   * @uname the user name to authenticate at the poddy server with
   * @pwd the password hash to authenticate at the poddy server with
   */
   public void saveStations(StationsList list,String uname,String pwd)
   {
   }

    
    
  /**
   * This method deletes stores a new schedule for a recording within the database
   * @param info the schedule information to be saved
   * @uname the user name to authenticate at the poddy server with
   * @pwd the password hash to authenticate at the poddy server with
   */
   public void saveRecording(RecordInfo info,String uname,String pwd)
   {
   }

}
