/*
 *	Widget.java 1.0 29.12.2008
 *
 * Copyright (c) 2004 Gavin & Georgina Sallery
 * Copyright (c) 2008 Virtual Worlds Productions
 * Email: virtual_worlds(at)gmx.de
 *
 * This program is free software; you can redistribute it and/or modify  it
 * under the terms of the GNU General Public License as published by the Free
 * Software Foundation; either version 2 of the License, or (at your option) any
 * later version.
 *
 * Please contact virtual_worlds(at)gmx.de if you are interested in a source
 * package which is not licensed under the GPL
 */

package com.vwp.jLCD;

public abstract class Widget 
{
   public static final int ALIGN_LEFT=1;   /** left-align the text */
   public static final int ALIGN_CENTER=2; /** center the text */
   public static final int ALIGN_RIGHT=1;  /** right-align the text */
   
    private Integer id;
            LCD lcd = null;
    private Screen screen = null;

    /**
     * @return the unique ID of this widget
     */
    public Integer getID() {
        return id;
    }

    void added(LCD lcd, Screen s, int id) {
        this.id = new Integer(id);
        this.lcd = lcd;
        this.screen = s;
        update();
    }

    abstract public String getType();
    abstract protected String getData();

    protected void update() {
        if (lcd != null)
            lcd.write("widget_set " + screen.getID() + " " + id + " " + getData());
    }
}
