/*
 * SystemLinuxAccess.java 1.0 10.12.2008
 *
 * Copyright (c) 2008 Virtual Worlds Productions
 * Email: virtual_worlds@gmx.de
 *
 * This program is free software; you can redistribute it and/or modify  it
 * under the terms of the GNU General Public License v2 as published by the Free
 * Software Foundation
 *
 * Please contact virtual_worlds@gmx.de if you are interested in a source
 * package which is not licensed under the GPL
 *
 * This software is provided "AS IS," without a warranty of any kind. ALL
 * EXPRESS OR IMPLIED CONDITIONS, REPRESENTATIONS AND WARRANTIES, INCLUDING ANY
 * IMPLIED WARRANTY OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE OR
 * NON-INFRINGEMENT, ARE HEREBY EXCLUDED. VIRTUAL WORLDS PRODUCTIONS AND ITS
 * LICENSORS SHALL NOT BE LIABLE FOR ANY DAMAGES SUFFERED BY LICENSEE AS A
 * RESULT OF USING, MODIFYING OR DISTRIBUTING THE SOFTWARE OR ITS DERIVATIVES.
 * IN NO EVENT WILL VIRTUAL WORLDS PRODUCTIONS OR ITS LICENSORS BE LIABLE FOR
 * ANY LOST REVENUE, PROFIT OR DATA, OR FOR DIRECT, INDIRECT, SPECIAL,
 * CONSEQUENTIAL, INCIDENTAL OR PUNITIVE DAMAGES, HOWEVER CAUSED AND REGARDLESS
 * OF THE THEORY OF LIABILITY, ARISING OUT OF THE USE OF OR INABILITY TO USE
 * SOFTWARE, EVEN IF VIRTUAL WORLDS PRODUCTIONS HAS BEEN ADVISED OF THE
 * POSSIBILITY OF SUCH DAMAGES.
 *
 * This software is not designed or intended for use in on-line control of
 * aircraft, air traffic, aircraft navigation or aircraft communications; or in
 * the design, construction, operation or maintenance of any nuclear
 * facility. Licensee represents and warrants that it will not use or
 * redistribute the Software for such purposes.
 */



package system;

import java.io.*;
import java.nio.*;
import java.text.*;
import java.util.*;
import java.util.zip.*;
import java.awt.event.*;
import java.awt.*;
import java.awt.image.*;
import javax.imageio.*;

import base.*;



class lirc extends Thread
{
   private SystemLinuxAccess parent;
   private Process           proc;
   private EventQueue        q = Toolkit.getDefaultToolkit().getSystemEventQueue();
   
   
   
   lirc(SystemLinuxAccess parent)
   {
      this.parent=parent;
      start();
   }
   
   
   
   public void run()
   {
      String         cmd1[]={"ircat","poddy"};
      String         last="",current;
      BufferedReader in;
      long           lastTime=System.currentTimeMillis();
      KeyEvent       event;
             
      try
      {
         proc=Runtime.getRuntime().exec(cmd1);
         in=new BufferedReader(new InputStreamReader(proc.getInputStream()));
         while (true)
         {
            try
            {
               current=in.readLine();
               event=null;
               if ((current!=null) && (current.length()>0) && (!parent.mainWin.processingKeyEvent) && 
                   ((!last.equalsIgnoreCase(current)) || (System.currentTimeMillis()-lastTime>300)))
               {
                  last=current;
                  if (current.equalsIgnoreCase("up"))
                   event=new KeyEvent(parent.mainWin, KeyEvent.KEY_RELEASED, System.currentTimeMillis(), 0, KeyEvent.VK_UP,KeyEvent.CHAR_UNDEFINED);
                  else if (current.equalsIgnoreCase("down"))
                   event=new KeyEvent(parent.mainWin, KeyEvent.KEY_RELEASED, System.currentTimeMillis(), 0, KeyEvent.VK_DOWN,KeyEvent.CHAR_UNDEFINED);
                  else if (current.equalsIgnoreCase("left"))
                   event=new KeyEvent(parent.mainWin, KeyEvent.KEY_RELEASED, System.currentTimeMillis(), 0, KeyEvent.VK_LEFT,KeyEvent.CHAR_UNDEFINED);
                  else if (current.equalsIgnoreCase("right"))
                   event=new KeyEvent(parent.mainWin, KeyEvent.KEY_RELEASED, System.currentTimeMillis(), 0, KeyEvent.VK_RIGHT,KeyEvent.CHAR_UNDEFINED);
                  else if (current.equalsIgnoreCase("set"))
                   event=new KeyEvent(parent.mainWin, KeyEvent.KEY_RELEASED, System.currentTimeMillis(), 0, KeyEvent.VK_ENTER,KeyEvent.CHAR_UNDEFINED);
/*                  else if (current.equalsIgnoreCase("jump_forward"))
                   event=new KeyEvent(parent.mainWin, KeyEvent.KEY_RELEASED, System.currentTimeMillis(), 0, KeyEvent.VK_F2,KeyEvent.CHAR_UNDEFINED);
                  else if (current.equalsIgnoreCase("jump_backward"))
                   event=new KeyEvent(parent.mainWin, KeyEvent.KEY_RELEASED, System.currentTimeMillis(), 0, KeyEvent.VK_F1,KeyEvent.CHAR_UNDEFINED);*/
                  else if (current.equalsIgnoreCase("play"))
                     event=new KeyEvent(parent.mainWin, KeyEvent.KEY_RELEASED, System.currentTimeMillis(), 0, KeyEvent.VK_F11,KeyEvent.CHAR_UNDEFINED);
                  else if (current.equalsIgnoreCase("stop"))
                   event=new KeyEvent(parent.mainWin, KeyEvent.KEY_RELEASED, System.currentTimeMillis(), 0, KeyEvent.VK_F12,KeyEvent.CHAR_UNDEFINED);
                  else if (current.equalsIgnoreCase("menu"))
                     event=new KeyEvent(parent.mainWin, KeyEvent.KEY_RELEASED, System.currentTimeMillis(), 0, KeyEvent.VK_PAGE_UP,KeyEvent.CHAR_UNDEFINED);
                  if (event!=null) q.postEvent(event);
                  lastTime=System.currentTimeMillis();
               }
               else if ((current==null) || (current.length()<=0)) com.vwp.util.Tools.threadSleep(150);
            }
            catch (Exception e)
            {
               e.printStackTrace();
               com.vwp.util.Tools.threadSleep(150);
               // TODO: check if ircat really exists and exit if not 
            }
         }
      }
      catch (Exception e)
      {
         e.printStackTrace();
      }      
   }
}



public class SystemLinuxAccess extends SystemAccess 
{
	static final String cd_discid="cd-discid";
	static final String cd_paranoia="cdparanoia";
	static final String cd_eject="eject";
	static final String flac="flac";
   static final String dvd_mount="/dvdmnt";
   static final String dd="dd";
   static final String lsdvd="lsdvd";
   static final String fuseiso="fuseiso";
   static final String fusermount="fusermount";
   static final String xine="xine";
   static final String nice="nice";
   static final String scantv="scantv";
   static final String xawtv="xawtv";
   static final String v4lctl="v4lctl";
   static final String ffmpeg="ffmpeg";
   static final String mount="mount";
   static final String umount="umount";
   static final String lame="lame";
   
   
   private Process xineproc=null,xawtvproc=null;
   
   
   
	public SystemLinuxAccess(PoddyFrame mainWin)
	{
	   super(mainWin);
	   new lirc(this);	   
	}
	

	
	public boolean isWorking()
	{
	   super.isWorking();
	   return (workCmd!=0);
	}
	
	
	public void run()
	{
      setPriority(Thread.MIN_PRIORITY);      
	   while (true)
	   {
	      if (workCmd==WORK_CMD_GRAB_DVD)
	      {
            Process  proc;

            mainWin.setTopPanelText("Hole DVD-Image...");
            String cmd1[]={dd,"if="+mainWin.config.dvd_device,"of="+path};          
            try
            {
               proc=Runtime.getRuntime().exec(cmd1);
               try
               {
                  proc.waitFor();
               }
               catch (InterruptedException ie)
               {
                  
               }
            }
            catch (IOException ioe)
            {
               ioe.printStackTrace();
            }	         
            try
            {
               String[] cmd={cd_eject,mainWin.config.dvd_device};
               Runtime.getRuntime().exec(cmd);
            }
            catch (IOException ioe)
            {
               ioe.printStackTrace();
            }
            workCmd=0;
	      }
	      else if (workCmd==WORK_CMD_GRAB_CD)
   	   {
   	      CDEntry  currEntry;
            Process  proc,currFlacProcess=null;
            int               cnt=0;
/*            BufferedReader    err;
            String            line;*/
   	      
   	      while (cnt<cdList.size())
   	      {
   	         currEntry=cdList.get(cnt);
   	      
               mainWin.setTopPanelText("Hole CD-Track "+currEntry.track+" / "+currEntry.totalTracks);
   	         String cmd1[]={nice,"-n","1",cd_paranoia,""+currEntry.track,"-d",mainWin.config.cd_device,"-q","-w",currEntry.cdpath+".grab"};   	      
   	         try
      	      {
      	         proc=Runtime.getRuntime().exec(cmd1);
      	         try
      	         {
      	            proc.waitFor();
      	         }
      	         catch (InterruptedException ie)
      	         {
      	            
      	         }
      	      }
      	      catch (IOException ioe)
      	      {
      	         ioe.printStackTrace();
      	      }

               if (cnt==cdList.size()-1)
               {
                  mainWin.setTopPanelText("CD fertiggestellt!");
                  try
                  {
                     String[] cmd={cd_eject,mainWin.config.cd_device};
                     Runtime.getRuntime().exec(cmd);
                  }
                  catch (IOException ioe)
                  {
                     ioe.printStackTrace();
                  }                  
               }

               if (currFlacProcess!=null) try
               {
                  currFlacProcess.waitFor();
               }
               catch (InterruptedException ie)
               {                    
               }              
                              
      	      String cmd2[]={nice,"-n","1",flac,"--totally-silent","-o",currEntry.cdpath,"--delete-input-file","--best","-f",currEntry.cdpath+".grab"};          
               try
               {
                  currFlacProcess=Runtime.getRuntime().exec(cmd2);
/*                  err=new BufferedReader(new InputStreamReader(currFlacProcess.getErrorStream()));
com.vwp.util.Tools.threadSleep(1000);                  
                  do
                  {
                     line=err.readLine();
                     if (line!=null) System.err.println(line);
                  }
                  while (true);//line!=null);*/
               }
               catch (IOException ioe)
               {
                  ioe.printStackTrace();
               }
               cnt++;
   	      }
   	      cdList.removeAllElements();
   	      workCmd=0;
   	   }
   	   else com.vwp.util.Tools.threadSleep(250);
	   }
	}
	
   
   
	public String getCDDiscID()
	{
		Process         proc;
 	   BufferedReader  in;

 	   super.getCDDiscID();
      try
      {
         String[] cmd={cd_eject,"-t",mainWin.config.cd_device};
         proc=Runtime.getRuntime().exec(cmd);
         
         try
         {
            proc.waitFor();
         }
         catch (InterruptedException ie)
         {
         }
      }
      catch (IOException ioe)
      {
         ioe.printStackTrace();
      }
 	   
		try
		{		
		   proc=Runtime.getRuntime().exec(cd_discid+" "+mainWin.config.cd_device);
		   in=new BufferedReader(new InputStreamReader(proc.getInputStream()));
		   return in.readLine();
		}
		catch (IOException ioe)
		{
			ioe.printStackTrace();
		}
		return null;
	}

	
	
	public void stopVideo()
	{
	   super.stopVideo();
	   turnOffTV();
	   if (xineproc!=null)
	   {
	      com.vwp.util.Tools.threadSleep(150);
	      xineproc.destroy();
	      xineproc=null;
	   }
	}
	
	
   public void playVideo(String videoPath)
   {
      super.playVideo(videoPath);      
      if (xineproc!=null) stopVideo();
      String cmd[];
      if (mainWin.config.is16_9)
      {
         String cmd3[]={xine,"-r","4:3","--no-splash","--auto-play=fq",videoPath};
         cmd=cmd3;
      }
      else
      {
         String cmd3[]={xine,"--no-splash","--auto-play=fq",videoPath};
         cmd=cmd3;         
      }
      try
      {
         xineproc = Runtime.getRuntime().exec(cmd);
         try
         {
            xineproc.waitFor();
         }
         catch (InterruptedException ie)
         {
            
         }
      }
      catch (IOException ioe)
      {
         ioe.printStackTrace();
      }
      
   }
	
	
	
	public void playDVD(String isoPath)
	{
	   super.playDVD(isoPath);
      if (xineproc!=null) stopVideo();
	   String cmd[];
	   if (mainWin.config.is16_9)
	   {
         String cmd3[]={xine,"-r","4:3","--no-splash","--auto-play=fq","dvd://"+isoPath};
         cmd=cmd3;
	   }
	   else
      {
         String cmd3[]={xine,"--no-splash","--auto-play=fq","dvd://"+isoPath};
         cmd=cmd3;
      }
      try
      {
         xineproc = Runtime.getRuntime().exec(cmd);
         try
         {
            xineproc.waitFor();
         }
         catch (InterruptedException ie)
         {
            
         }
      }
      catch (IOException ioe)
      {
         ioe.printStackTrace();
      }      
	}
	
	
	
   public void playDVDDirect()
   {
      super.playDVDDirect();
      playDVD(PoddyFrame.MyWin.config.dvd_device);      
   }
   
   
   
	public long getDVDDiscID()
	{
      String  title;
      CRC32   crc32 = new CRC32();
      int     timeout=0;
      File[]  vobs=null;
      Process proc;

      super.getDVDDiscID();
      try
      {
         String[] cmd={cd_eject,"-t",mainWin.config.dvd_device};
         proc=Runtime.getRuntime().exec(cmd);
         
         try
         {
            proc.waitFor();
         }
         catch (InterruptedException ie)
         {
         }
      }
      catch (IOException ioe)
      {
         ioe.printStackTrace();
      }
      try
      {
         String cmd1[]={lsdvd,"-x",mainWin.config.dvd_device};
         proc = Runtime.getRuntime().exec(cmd1);
         BufferedReader in=new BufferedReader(new InputStreamReader(proc.getInputStream()));
         do
         {
            title= in.readLine();
            if (title.contains("Disc Title: ")) break;
         }
         while ((title!=null) && (title!=""));
         title=title.substring(12);
      }
      catch (Exception e)
      {
         e.printStackTrace();
         return 0;
      }
      crc32.update(title.getBytes());

      File file=new File(getMainDirectory()+dvd_mount);
      file.mkdirs();
      String cmd2[]={fuseiso,mainWin.config.dvd_device,getMainDirectory()+dvd_mount};
      try
      {
         proc = Runtime.getRuntime().exec(cmd2);
         try
         {
            proc.waitFor();
         }
         catch (InterruptedException ie)
         {
         }         
      }
      catch (IOException ioe)
      {
         ioe.printStackTrace();
      }
          
      
      while (timeout<10)
      {
         vobs = new File(getMainDirectory()+dvd_mount+"/video_ts").listFiles(new FileFilter() 
         {
            public boolean accept(File pathname)
            {
               return pathname.isFile() && pathname.getName().endsWith(".vob");
            }
         });
         if (vobs!=null) break;
      }
      if (vobs==null) return 0;
      
      for (File vob : vobs) 
      {
         String name = vob.getName().toUpperCase();
         crc32.update(name.getBytes());
         ByteBuffer buf = ByteBuffer.allocate(8);
         buf.order(ByteOrder.LITTLE_ENDIAN);
         buf.putLong(vob.length());
         buf.flip();
         crc32.update(buf.get());
         crc32.update(buf.get());
         crc32.update(buf.get());
         crc32.update(buf.get());
      }

      String cmd3[]={fusermount,"-u",getMainDirectory()+dvd_mount};
      try
      {
         proc=Runtime.getRuntime().exec(cmd3);
         try
         {
            proc.waitFor();
         }
         catch (InterruptedException ie)
         {
         }
      }
      catch (Exception e)
      {
         e.printStackTrace();
      }
      
      return (crc32.getValue()^0xFFFFFFFFl);
   }
	
	
	
   public StationsList scanTV()
   {
      BufferedReader err,in;
      String         line,prevLine="";
      StationInfo    info;
      StationsList   list=new StationsList();
      File           file;
   
      super.scanTV();
      try
      {
         String[] cmd={scantv,"-n",mainWin.config.tv_norm,"-f",mainWin.config.freq_table,"-o","stations.tmp"};
         Process proc=Runtime.getRuntime().exec(cmd);
         err=new BufferedReader(new InputStreamReader(proc.getErrorStream()));
         do
         {
            line=err.readLine();
            if ((line!=null) && (line.length()>3)) mainWin.setTopPanelText(line);
         }
         while (line!=null);
      }
      catch (IOException ioe)
      {
         ioe.printStackTrace();
      }
      try
      {
         in=new BufferedReader(new FileReader("stations.tmp"));
         do
         {
            line=in.readLine();
            if ((line!=null) && (line!=""))
            {
               if (line.startsWith("channel ="))
               {
                  info=new StationInfo(prevLine.substring(1,prevLine.length()-1),line.substring(10));
                  list.stations.add(info);
               }
            }
            prevLine=line;
         }
         while (line!=null);
      }
      catch (IOException ioe)
      {
         ioe.printStackTrace();
      }
      file=new File("stations.tmp");
      file.delete();
      return list;
   }

   
   
   public void turnOnTV()
   {   
      turnOffTV();
      super.turnOnTV();
      try
      {
         String[] cmd={xawtv,"-f","-m","1>/dev/null","2>/dev/null"};
         xawtvproc=Runtime.getRuntime().exec(cmd);
      }
      catch (IOException ioe)
      {
         ioe.printStackTrace();
      }
      com.vwp.util.Tools.threadSleep(3000);
   }



   public void turnOffTV()
   {
      super.turnOnTV();
      if (xawtvproc!=null)
       xawtvproc.destroy();
      xawtvproc=null;
   }

   
   public void switchTVChannel(StationInfo info)
   {     
      super.switchTVChannel(info);
      try
      {
         String[] cmd={v4lctl,"-c",PoddyFrame.MyWin.config.video_device,"setchannel",info.channel};
         Runtime.getRuntime().exec(cmd);
      }
      catch (IOException ioe)
      {
         ioe.printStackTrace();
      }   
   }

   
   
   public void record(RecordInfo info,String channel,String recpath)
   {     
      Process proc;
      String  resolution="580x434" /*"480x360"*/,rate="25";
      String  offset;
      SimpleDateFormat formatter=new SimpleDateFormat("HH:mm:ss.000");
      DataOutputStream out;
      
      super.record(info,channel,recpath);
      try
      {
         String[] cmd={v4lctl,"-c",PoddyFrame.MyWin.config.video_device,"setchannel",channel};
System.out.println(channel);         
         proc=Runtime.getRuntime().exec(cmd);
         
         try
         {
            proc.waitFor();
         }
         catch (InterruptedException e)
         {
         }
      }
      catch (IOException ioe)
      {
         ioe.printStackTrace();
      }
      if (PoddyFrame.MyWin.config.tv_norm.toLowerCase().contains("ntsc"))
      {
         resolution="580x402";
         rate="30";
      }
      offset="00:00:0"+(Math.abs(PoddyFrame.MyWin.config.av_offset)/1000)+".";
      if (Math.abs(PoddyFrame.MyWin.config.av_offset)%1000<10) offset+="00"+Math.abs(PoddyFrame.MyWin.config.av_offset)%1000;
      else if (Math.abs(PoddyFrame.MyWin.config.av_offset)%1000<100) offset+="0"+Math.abs(PoddyFrame.MyWin.config.av_offset)%1000;
      else offset+=Math.abs(PoddyFrame.MyWin.config.av_offset)%1000;
      if (PoddyFrame.MyWin.config.av_offset<0) offset="-"+offset;

      try
      {
         out=new DataOutputStream(new FileOutputStream("ffmpeg.sh"));
         out.writeBytes(ffmpeg+" -itsoffset "+offset+" -y -f oss -ac 2 -i "+PoddyFrame.MyWin.config.audio_device+" -ab 128000 -pix_fmt yuyv422 -s "+resolution+" -r "+rate+" -f video4linux2 -i "+PoddyFrame.MyWin.config.video_device+" -vcodec mpeg2video -b 3200000 -t "+formatter.format((info.rtime*1000)-Calendar.getInstance().getTimeZone().getRawOffset())+" "+recpath+"/"+info.name.replace(" ","\\ ")+".mpg.avi 1>/dev/null 2>/dev/null");
         out.writeBytes("\n");
         out.flush();
         out.close();
      } 
      catch (IOException e)
      {
         e.printStackTrace();
      }
      
      try
      {
         String[] cmd={"bash","ffmpeg.sh"};
         recordProc=Runtime.getRuntime().exec(cmd);
      }
      catch (IOException ioe)
      {
         ioe.printStackTrace();
      }
      
   }


   
   public void stopRecording()
   {
      try
      {
         recordProc.waitFor();
      } 
      catch (InterruptedException e)
      {
         e.printStackTrace();
      } 
   }
   
   
   
   public void powerOff()
   {
	  try
	  {
	      String[] cmd={"sudo","shutdown","-h","now"};
	      Runtime.getRuntime().exec(cmd);
	  }
	  catch (IOException ioe)
	  {
	      ioe.printStackTrace();
	  }   
	  super.powerOff();
   }   

   
   
   public boolean mountUSB(String mountpoint)
   {
      File    file;
      Process proc;
      
      unmountUSB(mountpoint);
      super.mountUSB(mountpoint);
      file=new File(mountpoint+"/test.touch"); // create a file to test if mount has be done successfully
      try
      {
         file.createNewFile();
         
         String cmd2[]={mount,mountpoint};
         try
         {
            proc = Runtime.getRuntime().exec(cmd2);
            try
            {
               proc.waitFor();
            }
            catch (InterruptedException ie)
            {
   ie.printStackTrace();            
            }         
            file=new File(mountpoint+"/test.touch");
            if (!file.exists()) return true;
         }
         catch (IOException ioe)
         {
            ioe.printStackTrace();
         }
         return false;         
      }
      catch (IOException ioe)
      {
         ioe.printStackTrace();
      }
      return false;
   }
   
  
   
   public void unmountUSB(String mountpoint)
   {
      Process proc;

      super.unmountUSB(mountpoint);
      String cmd2[]={umount,mountpoint};
      try
      {
         proc = Runtime.getRuntime().exec(cmd2);
         try
         {
            proc.waitFor();
         }
         catch (InterruptedException ie)
         {
         }         
      }
      catch (IOException ioe)
      {
         ioe.printStackTrace();
      }
   }

   
   public void encodeToUSB(String srcPath, CDInfo cdInfo,TrackInfo trackInfo,String mountpoint,BufferedImage coverImage)
   {
      Process proc;
      String  targetPath,trackName;
      File    file;
      
      super.encodeToUSB(srcPath,cdInfo,trackInfo,mountpoint,coverImage);
      try
      {
         if (coverImage!=null)
          ImageIO.write(coverImage,"png",new File(getTempDirectory()+"image.png")); // should be optimized somehow: it is created/deleted for every track of the same album...
      }
      catch (IOException ioe)
      {
         ioe.printStackTrace();
      }
      String cmd1[]={flac,"-d",srcPath,"-o",getTempDirectory()+"track.wav"};
      try
      {
         proc = Runtime.getRuntime().exec(cmd1);
         try
         {
            proc.waitFor();
         }
         catch (InterruptedException ie)
         {
         }         
      }
      catch (IOException ioe)
      {
         ioe.printStackTrace();
      }
      targetPath=mountpoint+"/"+cdInfo.artist+"/"+cdInfo.album;
      file=new File(targetPath);
      file.mkdirs();
      
      trackName="/"+trackInfo.name.replace("*","-");
      trackName="/"+trackName.replace(" - "," ");

      String cmd2[]={lame,"-b","160","-h","-S",getTempDirectory()+"track.wav",targetPath+trackName+".mp3"};
      try
      {
         proc = Runtime.getRuntime().exec(cmd2);
         try
         {
            proc.waitFor();
         }
         catch (InterruptedException ie)
         {
         }         
      }
      catch (IOException ioe)
      {
         ioe.printStackTrace();
      }
      file=new File(getTempDirectory()+"track.wav");
      file.delete();

/*      String cmd4[]={"id3tag","-s"+trackInfo.name,"-a"+cdInfo.artist,"-A"+cdInfo.album,"-t"+trackInfo.trackNum,"-g"+cdInfo.genre,"-y"+cdInfo.year,targetPath+trackName+".mp3"};
      try
      {
         proc = Runtime.getRuntime().exec(cmd4);
         try
         {
            proc.waitFor();
         }
         catch (InterruptedException ie)
         {
         }         
      }
      catch (IOException ioe)
      {
         ioe.printStackTrace();
      }      */    
      
      String cmd3[]={"eyeD3","-t",trackInfo.name.substring(5),"-a",cdInfo.artist,"-A",cdInfo.album,"-n",""+trackInfo.trackNum,"-G",cdInfo.genre,"-Y",""+cdInfo.year,targetPath+trackName+".mp3"};
      try
      {
         proc = Runtime.getRuntime().exec(cmd3);
         try
         {
            proc.waitFor();
         }
         catch (InterruptedException ie)
         {
         }         
      }
      catch (IOException ioe)
      {
         ioe.printStackTrace();
      }      

      if (coverImage!=null)
      {
         String cmd5[]={"eyeD3","--add-image="+getTempDirectory()+"image.png:FRONT_COVER",targetPath+trackName+".mp3"};
         try
         {
            proc = Runtime.getRuntime().exec(cmd5);
            try
            {
               proc.waitFor();
            }
            catch (InterruptedException ie)
            {
            }         
         }
         catch (IOException ioe)
         {
            ioe.printStackTrace();
         }
         file=new File(getTempDirectory()+"image.png");
         file.delete();
      }      
   }
}


